module Api.Object.SmimeSignature exposing (..)

import Api.Enum.GitSignatureState
import Api.Object
import Graphqelm.Builder.Argument as Argument exposing (Argument)
import Graphqelm.Builder.Object as Object
import Graphqelm.Encode as Encode exposing (Value)
import Graphqelm.FieldDecoder as FieldDecoder exposing (FieldDecoder)
import Graphqelm.SelectionSet exposing (SelectionSet)
import Json.Decode as Decode


selection : (a -> constructor) -> SelectionSet (a -> constructor) Api.Object.SmimeSignature
selection constructor =
    Object.object constructor


email : FieldDecoder String Api.Object.SmimeSignature
email =
    Object.fieldDecoder "email" [] Decode.string


isValid : FieldDecoder Bool Api.Object.SmimeSignature
isValid =
    Object.fieldDecoder "isValid" [] Decode.bool


payload : FieldDecoder String Api.Object.SmimeSignature
payload =
    Object.fieldDecoder "payload" [] Decode.string


signature : FieldDecoder String Api.Object.SmimeSignature
signature =
    Object.fieldDecoder "signature" [] Decode.string


signer : SelectionSet signer Api.Object.User -> FieldDecoder signer Api.Object.SmimeSignature
signer object =
    Object.single "signer" [] object


state : FieldDecoder Api.Enum.GitSignatureState.GitSignatureState Api.Object.SmimeSignature
state =
    Object.fieldDecoder "state" [] Api.Enum.GitSignatureState.decoder
