module Api.Object.Status exposing (..)

import Api.Enum.StatusState
import Api.Object
import Graphqelm.Builder.Argument as Argument exposing (Argument)
import Graphqelm.Builder.Object as Object
import Graphqelm.Encode as Encode exposing (Value)
import Graphqelm.FieldDecoder as FieldDecoder exposing (FieldDecoder)
import Graphqelm.SelectionSet exposing (SelectionSet)
import Json.Decode as Decode


selection : (a -> constructor) -> SelectionSet (a -> constructor) Api.Object.Status
selection constructor =
    Object.object constructor


commit : SelectionSet commit Api.Object.Commit -> FieldDecoder commit Api.Object.Status
commit object =
    Object.single "commit" [] object


context : { name : String } -> SelectionSet context Api.Object.StatusContext -> FieldDecoder context Api.Object.Status
context requiredArgs object =
    Object.single "context" [ Argument.string "name" requiredArgs.name ] object


contexts : SelectionSet contexts Api.Object.StatusContext -> FieldDecoder (List contexts) Api.Object.Status
contexts object =
    Object.listOf "contexts" [] object


id : FieldDecoder String Api.Object.Status
id =
    Object.fieldDecoder "id" [] Decode.string


state : FieldDecoder Api.Enum.StatusState.StatusState Api.Object.Status
state =
    Object.fieldDecoder "state" [] Api.Enum.StatusState.decoder
